# coding: utf-8

"""
    VRt.Packer [PC]

    The version of the OpenAPI document: 6.10.2076

    Generated by OpenAPI Generator: 6.6.0

    Do not edit the code manually

    2023 Veeroute
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, conlist, constr
from vrt_lss_packer.models.attribute import Attribute
from vrt_lss_packer.models.coordinates import Coordinates
from vrt_lss_packer.models.dimensions import Dimensions
from vrt_lss_packer.models.package_type import PackageType

class Package(BaseModel):
    """
    Package.
    """
    key: constr(strict=True, max_length=1024, min_length=1) = Field(..., description="Package key, unique identifier.")
    type: PackageType = Field(...)
    body_dimensions: Dimensions = Field(...)
    container_dimensions: Dimensions = Field(...)
    container_coordinates: Coordinates = Field(...)
    attributes: Optional[conlist(Attribute, max_items=1000, min_items=0, unique_items=True)] = Field(None, description="Attributes. Used to add service information.")
    __properties = ["key", "type", "body_dimensions", "container_dimensions", "container_coordinates", "attributes"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Package:
        """Create an instance of Package from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of body_dimensions
        if self.body_dimensions:
            _dict['body_dimensions'] = self.body_dimensions.to_dict()
        # override the default output from pydantic by calling `to_dict()` of container_dimensions
        if self.container_dimensions:
            _dict['container_dimensions'] = self.container_dimensions.to_dict()
        # override the default output from pydantic by calling `to_dict()` of container_coordinates
        if self.container_coordinates:
            _dict['container_coordinates'] = self.container_coordinates.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in attributes (list)
        _items = []
        if self.attributes:
            for _item in self.attributes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['attributes'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Package:
        """Create an instance of Package from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return Package.parse_obj(obj)

        _obj = Package.parse_obj({
            "key": obj.get("key"),
            "type": obj.get("type"),
            "body_dimensions": Dimensions.from_dict(obj.get("body_dimensions")) if obj.get("body_dimensions") is not None else None,
            "container_dimensions": Dimensions.from_dict(obj.get("container_dimensions")) if obj.get("container_dimensions") is not None else None,
            "container_coordinates": Coordinates.from_dict(obj.get("container_coordinates")) if obj.get("container_coordinates") is not None else None,
            "attributes": [Attribute.from_dict(_item) for _item in obj.get("attributes")] if obj.get("attributes") is not None else None
        })
        return _obj

