# coding: utf-8

"""
    VRt.Packer [PC]

    The version of the OpenAPI document: 6.10.2076

    Generated by OpenAPI Generator: 6.6.0

    Do not edit the code manually

    2023 Veeroute
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List
from pydantic import BaseModel, Field, conlist, constr
from vrt_lss_packer.models.coordinates import Coordinates
from vrt_lss_packer.models.dimensions import Dimensions
from vrt_lss_packer.models.product_group_layout import ProductGroupLayout

class PackageLayout(BaseModel):
    """
    The layout of the product or other packaging in the package. 
    """
    package_key: constr(strict=True, max_length=1024, min_length=1) = Field(..., description="Package key.")
    coordinates: Coordinates = Field(...)
    dimensions: Dimensions = Field(...)
    product_group_layouts: conlist(ProductGroupLayout, max_items=70001, min_items=0) = Field(..., description="List of product group layouts.")
    package_layouts: conlist(PackageLayout, max_items=70001, min_items=0) = Field(..., description="List of package layouts.")
    __properties = ["package_key", "coordinates", "dimensions", "product_group_layouts", "package_layouts"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PackageLayout:
        """Create an instance of PackageLayout from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of coordinates
        if self.coordinates:
            _dict['coordinates'] = self.coordinates.to_dict()
        # override the default output from pydantic by calling `to_dict()` of dimensions
        if self.dimensions:
            _dict['dimensions'] = self.dimensions.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in product_group_layouts (list)
        _items = []
        if self.product_group_layouts:
            for _item in self.product_group_layouts:
                if _item:
                    _items.append(_item.to_dict())
            _dict['product_group_layouts'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in package_layouts (list)
        _items = []
        if self.package_layouts:
            for _item in self.package_layouts:
                if _item:
                    _items.append(_item.to_dict())
            _dict['package_layouts'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PackageLayout:
        """Create an instance of PackageLayout from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return PackageLayout.parse_obj(obj)

        _obj = PackageLayout.parse_obj({
            "package_key": obj.get("package_key"),
            "coordinates": Coordinates.from_dict(obj.get("coordinates")) if obj.get("coordinates") is not None else None,
            "dimensions": Dimensions.from_dict(obj.get("dimensions")) if obj.get("dimensions") is not None else None,
            "product_group_layouts": [ProductGroupLayout.from_dict(_item) for _item in obj.get("product_group_layouts")] if obj.get("product_group_layouts") is not None else None,
            "package_layouts": [PackageLayout.from_dict(_item) for _item in obj.get("package_layouts")] if obj.get("package_layouts") is not None else None
        })
        return _obj

