# coding: utf-8

"""
    VRt.Packer [PC]

    The version of the OpenAPI document: 6.10.2076

    Generated by OpenAPI Generator: 6.6.0

    Do not edit the code manually

    2023 Veeroute
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List
from pydantic import BaseModel, Field, conlist, constr
from vrt_lss_packer.models.coordinates import Coordinates
from vrt_lss_packer.models.dimensions import Dimensions
from vrt_lss_packer.models.product_layout import ProductLayout

class ProductGroupLayout(BaseModel):
    """
    The layout of the group of same (by key) product in the package. Product group - virtual package that combines the same (by key) product inside another package. 
    """
    product_key: constr(strict=True, max_length=1024, min_length=1) = Field(..., description="Package key.")
    coordinates: Coordinates = Field(...)
    dimensions: Dimensions = Field(...)
    product_layouts: conlist(ProductLayout, max_items=70001, min_items=0) = Field(..., description="List of product layouts.")
    __properties = ["product_key", "coordinates", "dimensions", "product_layouts"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ProductGroupLayout:
        """Create an instance of ProductGroupLayout from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of coordinates
        if self.coordinates:
            _dict['coordinates'] = self.coordinates.to_dict()
        # override the default output from pydantic by calling `to_dict()` of dimensions
        if self.dimensions:
            _dict['dimensions'] = self.dimensions.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in product_layouts (list)
        _items = []
        if self.product_layouts:
            for _item in self.product_layouts:
                if _item:
                    _items.append(_item.to_dict())
            _dict['product_layouts'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ProductGroupLayout:
        """Create an instance of ProductGroupLayout from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return ProductGroupLayout.parse_obj(obj)

        _obj = ProductGroupLayout.parse_obj({
            "product_key": obj.get("product_key"),
            "coordinates": Coordinates.from_dict(obj.get("coordinates")) if obj.get("coordinates") is not None else None,
            "dimensions": Dimensions.from_dict(obj.get("dimensions")) if obj.get("dimensions") is not None else None,
            "product_layouts": [ProductLayout.from_dict(_item) for _item in obj.get("product_layouts")] if obj.get("product_layouts") is not None else None
        })
        return _obj

